PROGRAM SB_Spiel;

{ c 1993 by Martin Rtz.
Ldt die Datei GLOCKEN.DAT von Dikette und spielt die
SONATA fr Glockenspiel von Georg Friedrich Hndel.
Hardware: SOUND-Blaster-Karte (Pro).
Quelle der Musik:  "Vom Glockenspiel zum Pianola" Seite 20
Dr. Alexander Bchner 1959 by Artia,Prag }

USES crt, sbc_tp6, dos;
CONST MaxAnzNoten = 9; MaxTakt = 100;
TYPE NotenStruktur = RECORD NName, NWert: byte END;
VAR TaktNr, NotenNr: byte;
    NotenIndex: ARRAY [1..MaxTakt,1..MaxAnzNoten] of NotenStruktur;
    MusFile: File of NotenStruktur;
{ ----------------------------------------------------------------------- }
PROCEDURE Bildschirm;
BEGIN
  textcolor (14); textbackground (1);clrscr;
  gotoxy(24,8);  write ('      Georg Friedrich Hndel');
  gotoxy(24,10); write ('*****      S O N A T A     *****');
  gotoxy(24,12); write ('         fr Glockenspiel');
  gotoxy(24,14); write (' fr PC bearbeitet von Martin Rtz');
  gotoxy(24,20); Write ('          mr - soft   1993');
  gotoxy(40,24);
END;
{ ----------------------------------------------------------------------- }
                     { Laden von Diskette }
PROCEDURE LoadDisk;
BEGIN
  assign(MusFile,'glocken.dat');                  { Name der Diskettendatei
                                                    wird zugeordnet         }
  reset(MusFile);                                 { Datei wird geffnet     }
  for TaktNr:=1 to MaxTakt do                     { vom 1. bis letzten Takt } 
      BEGIN
        NotenNr:=0;                             { Notennummer auf 0 stellen }
        repeat
          NotenNr:=succ(NotenNr);                     { nchste Notennummer }
          read(MusFile,NotenIndex[TaktNr,NotenNr]);   { lies Notennummer    }
        until (NotenIndex[TaktNr,NotenNr].NName=222)  { bis Kennzahl 222    }
          or  (NotenIndex[TaktNr,NotenNr].NName=0);   { oder 0 erscheint    }
      END;
  close(MusFile);
END;         { LoadDisk }
{ ----------------------------------------------------------------------- }
                          { Melodie spielen }
PROCEDURE MelodieSpiel;
CONST TdFaktor = 5000; stacc=100;              { Tempo und Nachklingen }
VAR Ton      : word;
    Tondauer : real;
    Takt     : byte;
BEGIN
  sbfd_program_change(0,7);                     { Instrument einstellen }
  for Takt:=1 to MaxTakt do                     { vom 1. bis letzten Takt }
    BEGIN
      NotenNr:=1;                               { Notennummer auf 1 stzen }
      while (NotenIndex[Takt,NotenNr].NName<>222) and  { wenn gltige     }
            (NotenIndex[Takt,Notennr].NName<>0) do     { Notennummern     }
        BEGIN
          with NotenIndex[Takt,NotenNr] do    { mit Feld der Notennummern }
            BEGIN
              Ton:= NName;                        { zu spielender Ton    }
              TonDauer:=  TdFaktor div NWert;     { Tondauer errechnen   }
            END;   { of with }

          sbfd_note_on(0,Ton,120);                { schaltet Ton ein     }
          delay (round(TonDauer));                { hlt Notenwert aus   }
          sbfd_note_off(0,Ton,120);               { schaltet Ton ab      }
          delay (stacc);                          { lt Ton nachklingen }
          NotenNr:=succ(NotenNr)                  { nchste Notennummer  }
        END;
    END;
END;     { von Melodiespiel }
{ ----------------------------------------------------------------------- }
                         { Hauptprogramm }
BEGIN
  sbfd_init;                                     { SB-Karte initialisieren }
    fillchar(NotenIndex,sizeof(NotenIndex),0);   { Speicherbereich wird
                                                   mit Nullen gefllt      }
     Bildschirm;
     LoadDisk;
     MelodieSpiel;
  sbfd_reset;                                    { SB-Karte zurcksetzen   }
   writeln('<ENDE>');delay (2000);
 clrscr
END.

